#!/bin/sh

source script_parser.sh

if [ ! -d /system/vendor/ ]; then
    mkdir -p /system/vendor/
    ln -s /lib/modules/`uname -r`/ /system/vendor/modules
    ln -s /boot/*.hcd /system/vendor/modules/
    ln -s /boot/*.bin /system/vendor/modules/
    ln -s /boot/*.txt /system/vendor/modules/
fi

ROOT_DEVICE="/dev/mmcblk0p7"
for parm in $(cat /proc/cmdline); do
    case $parm in
        root=*)
            ROOT_DEVICE=`echo $parm | awk -F\= '{print $2}'`
            ;;  
    esac
done

# install nand driver if we boot from sdmmc
nand_activated=`script_fetch "nand" "activated"`
if [ $nand_activated -eq 1 ]; then
    case $ROOT_DEVICE in
        /dev/mmc*)
  	    
        nand_module_path=`script_fetch "nand" "module_path"`
        if [ -n "$nand_module_path" ]; then
     	  	 insmod "$nand_module_path"
  	    fi
            ;;
    esac

fi

insmod /system/vendor/modules/disp.ko
insmod /system/vendor/modules/lcd.ko
#insmod /system/vendor/modules/hdmi.ko
# insmod ir driver
ir_activated=`script_fetch "ir" "activated"`
if [ $ir_activated -eq 1 ]; then
    ir_module_path=`script_fetch "ir" "module_path"`
    if [ -n "$ir_module_path" ]; then
        insmod "$ir_module_path"
    fi
fi

#insmod /system/vendor/modules/nt99141.ko
while true; do
    camera_activated=`script_fetch "camera" "activated"`
    echo "camera activated #$camera_activated"
    if [ $camera_activated -eq 1 ]; then
        echo "camera activated"
        module_count=`script_fetch "camera" "module_count"`
        if [ $module_count -gt 0 ]; then
            for i in $(seq $module_count); do
                key_name="module"$i"_path"
                module_path=`script_fetch "camera" "$key_name"`
                if [ -n "$module_path" ]; then
                    insmod "$module_path"
                    if [ $? -ne 0 ]; then
                        echo "insmod $module_path failed"
                        break 2
                    fi
                fi
            done
        fi
    else
        echo "camera not activated"
        break
    fi

    echo "camera module insmod done"
    touch /tmp/camera_insmod_done
done

# insmod touchscreen driver
tp_module_path=`script_fetch "tp" "module_path"`
if [ -n "$tp_module_path" ]; then
    insmod "$tp_module_path"

    # calibrate touchscreen if need
    tp_type=`script_fetch "tp" "type"`
    if [ $tp_type -eq 0 ]; then
        while true; do
            ts_calibrate
            if [ $? -eq 0 ]; then
                break
            fi
        done
    fi

    #ts_test
else
    echo "NO!!! touchscreen driver to be insmod"
fi

insmod /system/vendor/modules/ft5x_ts.ko #david 2014/12/5

############fsck check##########
fsck_check=`touch /mnt/disk/fsck_test_file`
if [ 0 -eq $? ];then
	echo "touch fsck_test_file success."
	rm /mnt/disk/fsck_test_file
else
	echo "touch fsck_test_file failed"
	e2fsck_force -f -p /dev/nandd
	reboot
fi
################################

#############telnet服务###########
#telnetd -l /bin/sh
#############ssh服务###########
/usr/local/sbin/sshd
############################
echo /sbin/mdev > /proc/sys/kernel/hotplug
mdev -s


#############wifi###########
insmod /lib/modules/3.4.39/8188eu.ko
sleep 1
ifconfig wlan0 up

/usr/sbin/wpa_supplicant -Dnl80211 -iwlan0 -c /etc/wpa_supplicant.conf -B
udhcpc -i wlan0 -n -q -t 6 &
#wpa_supplicant -i wlan0 -c /etc/wpa_supplicant.conf &
#insmod /system/vendor/modules/sunxi_emac.ko #david 2014/7/16
#insmod /system/vendor/modules/sun7i_tvd.ko #2014/10/15
#insmod /system/vendor/modules/sunxi_csi1.ko
insmod /system/vendor/modules/fm23.ko
#insmod /system/vendor/modules/icn85xx_ts.ko
#insmod /system/vendor/modules/leelen_hall_detect.ko

#sleep 4
sh /etc/init.d/auto_config_network
#ifconfig lo 127.0.0.1
sleep 1

#固定打开双核模式，避免在某个cpu使用率下反复开关cpu1,造成音频卡
echo 'maxpower'>/sys/class/sw_powernow/mode

/etc/UpDown* -qws &

cd /mnt/disk
/etc/start.sh &
